# LumaShow
A Lightshow Creating Solution, made for DMX compatible light fixtures. 

## Deps:
- [cmake](https://cmake.org/) for generating build files
- A c++ compiler [MinGW](https://www.mingw-w64.org/)
- Probably [git](https://git-scm.com/downloads)
- Probably a windows machine........ not sure if it builds on anything else (it won't right now, it hard requires windows.h but a HAL is on the todo list)

## Cloning
Clone the repo with git:
```bash
git clone https://github.com:/illyum/LumaShow.git
```
Or you can choose the *Download zip* option

Then, extract / navigate to the downloaded directory.
Create a build folder:
```bash
mkdir build
cd build
```

Use a generator to generate the build files. (Using ninja in this example)
```
cmake -G "Ninja" ..
```

Let this run, then build the project using:
```
cmake --build . -- -j
```
(The -j flag uses all cores to build faster)

You can also build a Visual Studio solution file. This is usually the default if you don't specify a generator to cmake:
```bash
cmake ..
```

This should create a project `.sln` file you can open with Visual Studio. Then, just hit F5!


### Libraries used:
- [Raylib](https://github.com/raysan5/raylib) Amazing library
- [rlImGui](https://github.com/raylib-extras/rlImGui) ImGui with Raylib Backend
- [Dear ImGui](https://github.com/ocornut/imgui) Little tooling
